<template>
    <div class="container">
        <div class="topBar">
          我的消息<span>({{totolNum}})</span>
            <div class="icon">
                <img :src="menu" @click="isShowDeleteBar=!isShowDeleteBar;multipleSection(isShowDeleteBar)" alt="">
            </div>
        </div>
        <div class="shadow"></div>
        <div class="main">
          <van-pull-refresh
            style="overflow:auto; background: #fff;"
            @refresh="onRefresh"
            v-model="isLoading"
            loosing-text="释放刷新项目列表..."
          >
            <div class="mes-list"><MessageComponent :message-data="messageList"></MessageComponent></div>
          </van-pull-refresh>
        </div>
        <div class="delete-bar">
          <div class="shadow" style="top:568px"></div>
          <van-submit-bar
            button-text="删除"
            @submit="deleteAll()"
          >
            <van-checkbox v-model="checked" style="position:fixed;left:20px;">全选</van-checkbox>
          </van-submit-bar>
        </div>
    </div>
</template>

<script>
import { Toast, Dialog } from 'vant'
import menu from '@/assets/menu.png'
import MessageComponent from './MessageComponent'
export default {
  name: 'Message',
  data () {
    return {
      totolNum: '',
      messageList: [],
      menu,
      checked: false,
      isShowDeleteBar: false,
      isShowCheckbox: false,
      userId: '',
      path:"ws://121.199.79.177:10201/message/api/",
      socket: "",
      isLoading: false,
      messageStream: [],
      originMsg:[],
    }
  },
  mounted () {
    this.init()
  },
  methods: {
    onRefresh(){
      setTimeout(() => {
        this.changeUI(this.originMsg);
        this.isLoading=false
      }, 500);
    },
    init: function () {
      if (typeof WebSocket === "undefined") {
        alert("您的浏览器不支持socket");
      } else {
        // 实例化socket
        this.userId = window.localStorage.getItem('userId');
        this.socket = new WebSocket(this.path+this.userId);
        // 监听socket连接
        this.socket.onopen = this.open;
        // 监听socket错误信息
        this.socket.onerror = this.error;
        // 监听socket消息
        this.socket.onmessage = this.getMessage;
      }
    },
    open: function() {
      console.info("[Socket Local] 连接成功");
    },
    error: function() {
      console.error("[Socket Local] 连接错误");
    },
    getMessage: function(msg) {
      var MesList = JSON.parse(msg.data)
      console.log(MesList)
      if (MesList.length === 1) {
        //如果在线，将最新一条push进原始数组
        this.originMsg.push({
          senderId: MesList[0].senderId,
          senderName: MesList[0].senderName,
          time: MesList[0].time,
          senderAvatarUrl: MesList[0].senderAvatarUrl,
          content: MesList[0].content,
          type: MesList[0].type
        })
        this.changeUI(this.originMsg)
      } else {
        this.originMsg = MesList //保存一条原始数组
        console.log(this.originMsg)
        this.changeUI(this.originMsg) //如果离线，直接导出
      }
    },
    changeUI (MesList) {
      var mes = dataDeal(MesList)
      function dataDeal (MesList) {
        var mesClassification = []
        MesList.forEach(function (el, index) {
          for (var i = 0; i < mesClassification.length; i++) {
            // 对比相同的字段key，相同放入对应的数组
            if (mesClassification[i].senderId === el.senderId) {
              mesClassification[i].listInfo.push({
                senderName: el.senderName,
                time: getLocalTime(el.time),
                senderAvatarUrl: el.senderAvatarUrl,
                content: el.content,
                type: el.type,
                isRead: false
              })
              return
            }
          }
          // 第一次对比没有参照，放入参照
          mesClassification.push({
            senderId: el.senderId,
            listInfo: [{
              senderName: el.senderName,
              time: getLocalTime(el.time),
              senderAvatarUrl: el.senderAvatarUrl,
              content: el.content,
              type: el.type
            }]
          })
          function getLocalTime (nS) {
            return new Date(nS).toJSON().substr(0, 19).replace('T', ' ')
          }
        })
        return mesClassification
      }
      this.messageList = mes;
      this.totolNum=this.originMsg.length
      console.log(this.messageList)
    },
    onClose(clickPosition, instance){
      let e = window.event;
      e.preventDefault();
      e.stopPropagation()
      instance.close();//这个函数就是让滑动的模块返回的操作  e.preventDefault()阻止默认行为;e.stopPropagation()阻止冒泡
      console.log('正在左滑')
    },
    deleteItem (index){
      this.originMsg.splice(index,1);
    },
    multipleSection (isShow) {
      if (isShow) {
        console.log('change UI,出现多选框')
        this.isShowCheckbox = true
        document.getElementsByClassName('delete-bar')[0].style.display = 'block'
      } else {
        document.getElementsByClassName('delete-bar')[0].style.display = 'none'
      }
    },
    deleteAll () {
      console.log('删除试试')
      Dialog.confirm({
        title: '注意',
        message: '确认删除消息？'
      }).then(() => {
        this.checked = false
        document.getElementsByClassName('delete-bar')[0].style.display = 'none'
        document.getElementsByClassName('mes-list')[0].style.display = 'none'
        this.totolNum=0
      }).catch(() => {
        // on cancel
        document.getElementsByClassName('delete-bar')[0].style.display = 'none'
        this.checked = false
      })
    },
  },
  components: {
    MessageComponent
  }
}
</script>
<style scoped lang="less">
    .container {
        display: flex;
        flex-direction: column;
        .shadow {
            position: fixed;
            top:54.5px;
            height: 3.5px;
            width: 100%;
            left: 0;
            background: #f7f7f7;
            z-index:999 ;
        }
        .topBar {
            display:flex;
            flex-direction: row;
            align-items: center;
            justify-content: center;
            font-size: 17.7px;
            letter-spacing:3px;
            text-indent: 3px;
            font-weight: bold;
            color: #8c8c8c;
            height:54.5px;
            width:100%;
            position:fixed;
            top:0;
            background: #fff;
            z-index: 999;
            .icon{
                position: absolute;
                right: 12px;
                top: 15px;
                img{
                    width: 19.6px;
                    height:11px;
                }
            }
        }
        .main {
            overflow: auto;
            margin-top: 58px;
            padding-bottom: 52.5px;
            min-height:80vh;
            .list {
                display: flex;
                align-items: center;
                background: #fff;
                padding: 8.5px 6.13% 8.5px 3.2%;
                margin-bottom:0.5px;
                .head-img {
                    width: 61px;
                    height: 61px;
                    border: 1px solid #707070;
                    background: #EEEEEE;
                    border-radius: 50%;
                }
                .center {
                    flex:1;
                    overflow:hidden;
                    padding-left:12.5px;
                    padding-right:12.5px;
                    .title {
                        font-size: 14px;
                        color: #3d3d3d;
                        font-weight: bold;
                        margin-top:15px;
                        margin-bottom:11.5px;
                    }
                    .desc {
                        font-size: 11.5px;
                        color: #3d3d3d;
                        overflow: hidden;
                        text-overflow: ellipsis;
                        white-space: nowrap;
                    }
                }
                .num {
                    display: flex;
                    align-items: center;
                    justify-content: center;
                    background:#EF4C4C;
                    color: #fff;
                    width: 18.5px;
                    height:18.5px;
                    border-radius: 50%;
                    font-size: 12px;
                    font-weight:bold;
                    min-width: 18.5px;
                }
                &:last-child {
                    border-bottom: none;
                }
            }
        }
        .delete-bar{
          display:none;
          /deep/.van-submit-bar{
            position:fixed;
            bottom:49px;
          }
          .van-submit-bar__bar{
            padding: 0 16px;
          }
          .van-submit-bar__button {
            width: 95px;
            height: 40px;
            font-weight: 500;
            line-height: 40px;
            border: none;
            padding: 0 15px;
            font-size: 15px;
          }
          /deep/.van-button--danger {
            background: -webkit-linear-gradient(left, #ff6034, #ee0a24);
            background: linear-gradient(to right, #ff6034, #ee0a24);
          }
          /deep/.van-button--square {
            border-radius:20px;
          }
        }
    }
</style>
